- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
       █▄▄ █░░ ▄▀█ █▀ ▀█▀ █▄▄ █▀▀ ▄▀█ ▀█▀ █▀
       █▄█ █▄▄ █▀█ ▄█ ░█░ █▄█ ██▄ █▀█ ░█░ ▄█
                      Change Log
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
7.1 LOG
Fixed Step Stutter automation playback, including consecutive programmed stutter steps at the same rate.

7.0 LOG
Major improvements to SD card compatibility and song-data reliability.
Safer saving helps protect songs and settings from interrupted or failed card writes.
Faster saving, especially when saving a song without many changes.
The REC LED now clearly indicates card activity during startup, saving, and loading.
Fixed the last selected song not being restored after reboot.
Fixed pattern page lengths not being restored correctly by redo.
Improved VGM file scanning and compatibility with computer-generated hidden files.
General timing, performance, and stability improvements.

Fixed VGM Jukebox playback of compressed .vgz files. Some files could start, hold the first note, and fail to advance because gzip streams were not keeping the required decompression history.
Improved OPL2/YM3812 VGM compatibility when playing through the YMF262/OPL3 chip.
VGM Jukebox mode now supports .vgm and .vgz files directly for supported OPL/OPL2/OPL3 streams.
Optimized the timer ISR by fixing the vibrato/tremolo reciprocal cache so unchanged LFO settings no longer redo expensive division every tick.

6.5 LOG
Fixed a bug where audio routing and MIDI channel settings could appear to save, then be lost after power-off.
Fixed a routing preset save/load bug that could cause an empty preset or no sound after reboot.
Fixed output routing in the online tool so outputs 1/2 and 3/4 are no longer swapped.
Fixed the online tool so routing changes are applied to the hardware immediately.
Reduced a web-tool related issue that could, in some cases, make the machine appear to freeze for a few seconds during playback.
Fixed a bug where a save started during playback could be cancelled if you left Save mode before stopping the machine. Queued saves now remain pending until they are actually written.


6.4 LOG
Further optimizations to card handling: a solidly lit REC LED now indicates card activity, replacing the progress bar, which could interfere with transfers and slow down operation.

6.3 LOG
Fixed a bug causing some R2 units to freeze when SD card was accessed

6.2 LOG
Online tool protocol optimised 
Fixed a bug causing some R2 units to freeze

6.1 LOG
Added Multiple and Decay faders to Scene Morphing mode (previously only volumes in 6.0).
Added Pattern visualisation and editing to the online tool.
Fixed a bug where shortening a pattern could cause playback to stall.
Fixed a bug with R1 units streaming corrupt data to tool over USB

6.0 LOG
Implemented MIDI over USB
Added new Morphing Mixing Scenes mode that lets you store and smoothly fade between different kit mixes.
Press KIT + STEP to enter the mode, then save up to ten mix scenes and choose how long the fade lasts (from instant to one bar).
Trigger any saved scene to crossfade between mixes in real time.
➡️ See page 25 of the user manual for full details.

Added ability to trigger mutes and solos via MIDI on arbitrary MIDI channels.

Program Change messages allow to change patterns and kits via MIDI

Fixed issue causing vibrato malfunction
Kit now updates properly after loading a song (previously, some items didn’t update)
Introduced an improved online tool allowing arbitrary MIDI channels for mutes, solos, and program changes

5.0 LOG
Optimized SD card handling for much faster read and write speeds
Added option to select between 1 PPQ and 4 PPQ (original speed) — hold Function + Rec and press Tempo to toggle
Sync output now correctly follows the selected PPQ setting

4.6 LOG
 Fixed a bug that prevented some settings from being saved after power-off
 MIDI Tool Update 1.4: Added a short pause between messages to prevent some MIDI interfaces from skipping value changes
 Note: If you still see Tool v1.3, please perform a hard refresh (Shift+F5) in your browser.

4.5 LOG
Fixed a bug preventing VGM mode to function properly on R1 units

4.4 LOG
Fixed a bug where the right ear of the headphone output would be muted after adjusting the volume.

4.3 LOG
Addressed a noise issue with the MIX OUTPUT
Please refer to NOISY MIX Readme & Fix PDF for details.

4.2 LOG

FIXES
Hi-hats & cymbals were blinking the wrong activity LEDs – corrected.
Factory reset via Clear on startup now works correctly.
Fixed VGM mode.
Fixed Envelope Safe/Unsafe Length startup shortcut.
Removed erroneous chasing LED during Key Change Edit Mode.
Disabled double-clicking of the Clear button when Wiggle is held to prevent accidental pattern reset when attempting to reset wiggles.
Reworked LED indicators in Song Mode for better clarity:
Upon entering Song Mode, the Top Bank and Bottom Song LEDs are first solid, indicating the current bank and song (like before).

NEW
When pressing a Top Bank button to change folders, the new folder's LED blinks to indicate a pending folder change. All Bottom Song buttons also blink, prompting you to select a song to load within the new folder.
If you exit Song Mode and return to it, the LEDs revert to their solid state.
When you disable the stutter sequencer using Func + Stutter while a stutter is active, the stutter will stop immediately.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

4.1
-  Fixes  -
-Reconfigured MIX output amplifier to solve buzzing that occured on some units

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

4.0
This update is substantial, with numerous fixes and additions. Many aspects of the synthesizer have been improved and redesigned. As a result, it's possible that some patterns may sound slightly different.

The factory presets have been adjusted for version 4.0 and are included in the firmware zip.

- Most Notable Features -
-Musical scales and modes have been added to the transpose mode.
-True polyrhythms: each track can have its own page and step length.
-Kits sandboxing per song: copy a KITS folder into a song folder to isolate the kits from other songs.
-40 discrete kits are available per song at once (10 kits x 4 variations), increased from 10.
-Redesigned vibrato engine offering 3 speed ratios (up to audio rates) and extended overall depth control.
-Redesigned stutter engine offering 2 modes: Stutter and drill/ratcheting.
-Trick automations can be enabled/disabled on the fly.
-Nudges/microstepping values can be set for all steps at once (to quantize or offset a track).
-Nudge wiggle enables random microstepping.
-Routing presets

- Most Notable Fixes -
-Memory leak causing units to sometimes freeze during a save or load has been addressed.
-UI glitches (slow updating LED) have been fixed.
-Tracks going out of sync after a stutter has been resolved.


- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
3.3
-  Fixes  -
-Fixed a bug that could lead to freezing when saving (only affecting R2 units)
-Fixed a bug that could lead to corrupt LED chasing after a song change


3.2
-  Features  -
-Polyrhythms: Users can now independently adjust the length of a track without affecting others. To modify the length, hold down the 'Function' key while using the bottom buttons. Additionally, you can swiftly switch between tracks without exiting the length mode by holding the 'Function' key and pressing the top buttons. 
Important: Track 1 (BD) serves as the master track, controlling the timing of page transitions and the chaining of patterns.

-Octave Offset Range: The lower range has been extended. You can now access an additional octave below by holding the top button and pressing the 'Kit/Patt' button a second time.

-  Fixes  -
-Resolved an issue where incorrect frequencies were being applied following multiple rapid bend tricks.
-Resolved a bug causing the tool to report an incorrect FW version number.

3.1
-  Fixes  -
-Fixed a bug causing the mix signal to bleed through the sync connector
-Fixed wiggle (only applies to R2 units)

3.0
-  Fixes  -
-Fixed a bug causing the unit to stall when synched to MIDI clock 

- New Features -
Added a checkbox to the tool allowing to ignore incoming MIDI notes (should you only want to sync to MIDI clock)

2.9
-  Fixes  -
-Fixed bug that prevented some units from entering VGM/Jukebox mode

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

2.8
- New Features -

  VGM Jukebox mode
  - BlastBeats can now read VGM files
Create a VGM folder on the root of the SD card and add 10 subfolders labelled 1 to 10 inside the VGM folder (or copy over the updated factory presets zip file from the website)
Each folder is a bank of songs and can be accessed by pressing top buttons 1-10 on the BlastBeats. Each bottom row button corresponds to a song (up to 16 songs are read per folder).
Hold TEMPO at startup to launch VGM mode. ONLY .VGM files supported, compressed files need to be converted (details in manual)

Automation engine
 now only transmits MIDI CC for unmuted tracks

Wiggle mode
  - New option to lock the wiggled value on active steps (activate via the online tool)
  - You can now disconnect individual faders from the Wiggle by holding Wiggle+Clear and moving a fader
  Please note: Releasing Wiggle+Clear without moving any fader disconnects *all the faders* from Wiggle

  Clear mode
  - Top row buttons now shows the selected track and can be used to select another track
  - Hold Clear+Top row button: Clears both track steps and automation data on the selected track
  - Hold Clear+Rec once: Only clears the automation data on the selected track
  - Hold Clear+Rec twice: Clears the automation data on all tracks

  P-locks
  - P-locked steps now send MIDI CC data to external devices
  - P-locked steps can now be copy-pasted

  Mute Page mode
  - While Function+Mute are held, page buttons can be deactivated (blinking when inactive) and playback skips them (e.g. you can loop pages 1 and 3 only, or page 2, 3 and 4, etc.)

  Wonky Swing mode
  - Pressing Swing while holding Function activates "Wonky Swing": instead even numbered steps, odd numbered steps are offsets by Swing

  Step mode display enhancement
  - When selecting a synth track and moving some of its faders, the algorithm used by this track is shown by a blinking LED (top row LED's 1-5, to reflect algorithms 1-5)

-  Fixes  -
-Fixed bug that prevented transpositions from being saved under certain conditions 
-Fixed a bug causing the a jump to another track when editing the nudge

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  

2.7
-  Fixes  -
Fixed bug that limited the Undo/Redo performance
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
2.6
- New Features -
Automation engine now transmits MIDI CC when on unmuted tracks
-  Fixes  -
Synth step would toggle when attempting to transpose note below zero
Better handling of page length shortening (skips to previous page if beyond new length)
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
2.5
-  Fixes  -
Fixed bug introduced in 2.4 that mutes synth part when REC is pressed
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
2.4 (NOT RECOMMENDED)
-  Fixes  -
Synth step couldn’t be cloned when set to the lowest note
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
2.3
- New Features -
Recordable Key changes! 
Hold step and press run to access the key change editor
-Clone step now copies parameter locks (for synths and drums)
-Parameter locks update synth engine only when sequencer reaches them (not during PLOCK editing) 

-  Fixes  -
Fixed a bug causing the the mode to change to function when transposing a synth step up
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
2.2
- New Features -
New configuration Tool twistedelectrons.com/tool
Synth steps can be copy/pasted and individually transposed
Kits can be cloned from one bank to another
MIDI note numbers of drum parts can be redefined 

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
2.1
- New Features -
Responds to MIDI clock continue

-  Fixes  -
Fixed a bug causing the sequencer to trigger a tick early when synched to MIDI clock
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
2.0
- New Features -
Pattern rotation (1 step at a time, forward or backward):
In step mode hold step, then press function for forward or kit/patt for backward.

Record/Punch with nudge (aka unquantified)
Hold rec and press tempo to toggle quantising on or off (default is on).
When quantising is off nudge is added to recorded steps, allowing to punch/record notes in-between steps.

-  Fixes  -
Fixed a bug preventing synth patterns to be saved under certain conditions
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
1.9
- New Features -
Step Nudging/Delaying:
Hold a step in step mode and use the top 10 buttons to set delay amount (0-90% of a step). 
Automation is now saved with kit & pattern saves (previously only pattern)

-  Fixes  -
Bd modulator mult: wider range and improved rise/fall rates
Optimised parameter lock engine, disabled when playing synths in monitor mode (avoiding accidental p-lock recording)
Fixed a memory leak.
Fixed a bug causing some changes not to be saved.Snare waveform display fixed: waveforms that silence the snare (4,5,6) are changed to 3 
Fixed a bug causing occasional mode to change when playing synths with buttons.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
1.8
-  Fixes  -
Fixed a bug preventing the drum pattern changes to be saved under certain conditions
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
1.7
- New Features -
Kit Preview: when changing kits with blast beats stopped, the new kit is previewed
Arbitrary stutter step: Hold function and press a bottom button while stuttering to change the step.
-  Fixes  -
Fixed a bug causing the stutter to glitch under certain conditions
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
1.6
- New Features -
Synth notes can now be punched in realtime when the sequencer is playing,  even in step rec mode.
You can now zero all faders (silence kit): double tap the clear button when in clear mode.
-  Fixes  -
-trick automation wasn't cleared during automation clear
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

1.5
New Features 
-Non realtime step fader lock a.k.a Parameter locks (hold a bottom button in step mode and move a fader to assign - REC must be OFF)
-Added a LED animation after saving
 Fixes  
-fixed out of bounds snare multiplier wiggling
-fixed a bug preventing synth op3 to modulate op4 in algo 3
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
1.4 

New Features
-the current step is displayed via flashing LED when using step rec to input notes.
-add rests during step record by pressing step

 Fixes
-fixed a bug preventing to preview synths on bottom buttons with rec armed, sequencer stopped and step record off.
-fixed a bug causing sequencer to stop after removing cable from sync in jack
-fixed a bug tempo to become faster after powerup
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 


Blast Beats R1.3
-Fixed a bug causing occasional undesired change of mode when playing synths live in monitor mode.
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
Blast Beats R1.2
-Pattern Length is applied to all pages (resets to first step of next page when last step is reached)
-Fixed a LED bug (turned off when changing song with sequencer running)
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
Blast Beats R1.1
-Fixed a bug preventing to step record synth parts with the buttons.
